/*
** AUTHORS:
** Rama Alebouyeh (rama[at]cs.ucsb.edu)
** Matthew S Allen (msa[at]cs.ucsb.edu)
*/

#ifndef _CHIMERA_MESSAGE_H_
#define _CHIMERA_MESSAGE_H_

#include "key.h"
#include "host.h"
#include "jrb.h"

#define DEFAULT_SEQNUM 0 

typedef struct {
  Key dest;
  int type;
  int size;
  char *payload;
  Key source;           /* for future security enhancement */
  unsigned long seqNum; /* for future security enhancement */
} Message;

typedef void (*messagehandler_t)(ChimeraState *, Message *);

void* message_init(void *chstate, int port);
void message_recieved(void *chstate,char *data, int size);
void message_handler(void *chstate,int type, messagehandler_t func, int ack);
int message_send(void *chstate,ChimeraHost *host, Message *message, int retry);
Message *message_create(Key dest, int type, int size, char *payload);

#endif /* _CHIMERA_MESSAGE_H_ */
